//To set Editable FieldValue
function setEditableFieldValue(element, newVal){
    if(element.oldvalue!=newVal){
    	element.value = newVal;
    	element.oldvalue = newVal;
    }
}

////////////////////////////// CG Calculation Starts /////////////////////////////////

//To caluclate sum of CG Deductions
function addCGDeductions(tableId){
	try{
	var tab = document.getElementById(tableId);
	var inputs = tab.getElementsByTagName("INPUT");
	var sum = 0;
	for(var i=0;i<inputs.length;i++){
		if(inputs[i].name.match('amount$')){
			sum = parseInt(sum) + parseInt(coalesce(inputs[i].value));
		}
	}
	return sum;
	}catch(e){
		alert(e);
	}
}


//To setOfff STCG With A7
function calcBulidingSellSTCG(){

	var table = document.getElementById('scheduleCGstcg1');
	var noOfRows = table.rows.length;


	var temp=parseInt('0',10);
	var temp1=parseInt('0',10);
	var capgainonAssetsTemp = parseInt('0',10);

	for (var i = 0; i <noOfRows/13; i++) {
		//calculate deduction
		var totalDedn = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].deductSec48totalDedn')[0];
		totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].deductSec48aquisitCost') +
                coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].deductSec48improveCost') +
                coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].deductSec48expOnTrans'));

		//calcBalance
		   var balanceCG = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].balanceCG')[0];
		   balanceCG.value = eval(coalesce(document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].fullConsideration50C')[0].value) -
		                    coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].deductSec48totalDedn'));

		   var capgainonAssets = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].capgainonAssets')[0];
		   var exemptionOrDednUs54 = coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild['+i+'].exemptionOrDednUs54');
		   if(parseInt(balanceCG.value) > parseInt(0,10)){
		   capgainonAssets.value = zeroOrMore(eval(parseInt(balanceCG.value) -
		                    		parseInt(exemptionOrDednUs54)));
			} else {
				capgainonAssets.value = parseInt(balanceCG.value);
			}

		   capgainonAssetsTemp = parseInt(capgainonAssets.value) + parseInt(capgainonAssetsTemp);

	}
	 var capgainonAssets = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild.capgainonAssets')[0];
	 capgainonAssets.value = eval(parseInt(capgainonAssetsTemp,10));


   //gain on asset

}

//To calculate equity sell STCG
function calcEquitySellSTCG(cgosIncome){

	var tab = document.getElementById('scheduleCGstcg2');
	var len = tab.tBodies.length;
	var sum = 0;
	for(var i=0;i<len;i++){
		//Calc deduction
	    var totalDedn = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].deductSec48.totalDedn')[0];
	    totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].deductSec48.aquisitCost') +
	                           coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].deductSec48.improveCost') +
	                           coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].deductSec48.expOnTrans'));

	    //calcBalance
	    var balanceCG = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].balanceCG')[0];
	    balanceCG.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].fullConsideration') -
	    					   totalDedn.value);

	    //gain on equity share
	    var capgainonAssets = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].capgainonAssets')[0];
	    capgainonAssets.value = eval(parseInt(balanceCG.value, 10) +
	                     coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT['+ i +'].lossSec94of7Or94of8'));

	    var section = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT[' + i +  '].section')[0].value;
	    if(section=='1A'){
	    	sum = parseInt(sum) + parseInt(capgainonAssets.value);
	    }else if(section=='5AD1biip'){
	    	cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii = capgainonAssets.value;
	    }

	}
	return sum;
}

//To calculate securities sell STCG
function calcSecuritiesSellSTCG(){
	//Calc deduction
    var totalDedn = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.deductSec48.totalDedn')[0];
    totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.deductSec48.aquisitCost') +
                           coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.deductSec48.improveCost') +
                           coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.deductSec48.expOnTrans'));

    //calcBalance
    var balanceCG = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.balanceCG')[0];
    balanceCG.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.fullConsideration') -
    					   totalDedn.value);

    //gain on Securities
    var capgainonAssets = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.capgainonAssets')[0];
    capgainonAssets.value = eval(parseInt(balanceCG.value, 10) +
                     coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.lossSec94of7Or94of8'));
}

//To calculate other STCG assets
function calcOtherAssetSellSTCG(){
	//Calc deduction
    var totalDedn = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.deductSec48.totalDedn')[0];
    totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.deductSec48.aquisitCost') +
                           coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.deductSec48.improveCost') +
                           coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.deductSec48.expOnTrans'));

    //calcBalance
    var balanceCG = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.balanceCG')[0];
    balanceCG.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.fullConsideration') -
    					   totalDedn.value);

    //gain on Securities
    var capgainonAssets = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.capgainonAssets')[0];
    capgainonAssets.value = eval(parseInt(balanceCG.value, 10) +
                     coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.lossSec94of7Or94of8'));
}

//To calculate STCG DTAA tax
function calcDtaaTaxSTCG(){

//	var totAmtStcgUnderDtaa = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.totAmtStcgUnderDtaa')[0];
//
//
//	totAmtStcgUnderDtaa.value = addCGDeductions('scheduleStcgDtaa');
//
}

//To calculate STCG
function calculateSTCG(cgosIncome){

	calcBulidingSellSTCG();
    var sum = calcEquitySellSTCG(cgosIncome);
    calcSecuritiesSellSTCG();
    calcOtherAssetSellSTCG();

    calcDtaaTaxSTCG();

    var totalSTCG = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.totalSTCG')[0];
    totalSTCG.value = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild.capgainonAssets') +
            				parseInt(sum) +
            				parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii) +
            				coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRITransacSec48Dtl.nRItaxSTTPaid') +
            				coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.totAmtStcgUnderPTI') +
            				coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRITransacSec48Dtl.nRItaxSTTNotPaid') +
            				coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.capgainonAssets') +
            				coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.capgainonAssets') +
            				coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.unUtilizedCapGain54.totAmtStcgUnderDtaa') -
            				coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.totalAmtNotTaxUsDTAAStcg'));

    cgosIncome.cgInc.stcg.prctg30.sec115AD = coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRISecur115AD.capgainonAssets');
    cgosIncome.cgInc.stcg.prctg30.secPti = coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.ptiStcg30');
	cgosIncome.cgInc.stcg.prctgAr.stcgApp = eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleofLandBuild.capgainonAssets') +
										coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRITransacSec48Dtl.nRItaxSTTNotPaid') +
										coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.saleOnOtherAssets.capgainonAssets') +
										coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.unUtilizedCapGain54.totAmtStcgUnderDtaa'));

	cgosIncome.cgInc.stcg.prctgAr.secPti=coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.ptiStcgAr');

	cgosIncome.cgInc.stcg.prctg15.sec111a = eval(parseInt(sum) +
										 coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.nRITransacSec48Dtl.nRItaxSTTPaid') );
	cgosIncome.cgInc.stcg.prctg15.secPti = coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.ptiStcg15');

	document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden')[0].value=eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.totAmtStcgUnderDtaa'));
	document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden')[0].value=eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.ltcgUnderDtaa.totAmtLtcgUnderDtaa'));


}

//To calculate building sell LTCG
function calcBulidingSellLTCG(){
	try{

		var table = document.getElementById('scheduleCGltcg1');
		var noOfRows = table.rows.length;


		var temp=parseInt('0',10);
		var temp1=parseInt('0',10);
		var capgainonAssetsTemp=parseInt('0',10);


		for (var i = 0; i <noOfRows/14; i++) {
			//calculate deduction
			var totalDedn = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].deductSec48totalDedn')[0];
			totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].deductSec48aquisitCost') +
	                coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].deductSec48improveCost') +
	                coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].deductSec48expOnTrans'));

			//calcBalance
			   var balanceCG = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].balanceCG')[0];
			   balanceCG.value = eval(coalesce(document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].fullConsideration50C')[0].value) -
			                    coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].deductSec48totalDedn'));

			   //gain on asset
			   var capgainonAssets = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].capgainonAssets')[0];

			   var exemptionOrDednUs54 = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].exemptionOrDednUs54')[0];
			   var j = i+1;
			   var tableId = 'ltcgDeduction1_ded'+j;

				var table2 = document.getElementById(tableId);
				var noOfRows2 = table2.rows.length;

				var temp=parseInt('0',10);

					for(var j = 0; j <noOfRows2-3; j++){
						temp = parseInt(temp) + eval(parseInt(coalesce(document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].exemptionOrDedn['+j+'].amount')[0].value),10));
					}

			   exemptionOrDednUs54.value = temp;

			   if(parseInt(balanceCG.value) > parseInt(0,10)){
			   capgainonAssets.value = zeroOrMore(eval(parseInt(balanceCG.value) -
			                    			parseInt(exemptionOrDednUs54.value)));
				} else {
				capgainonAssets.value = parseInt(balanceCG.value);
				}

			   capgainonAssetsTemp = parseInt(capgainonAssets.value) + parseInt(capgainonAssetsTemp);
		}

		var capgainonAssets = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild.capgainonAssets')[0];
		 capgainonAssets.value = eval(parseInt(capgainonAssetsTemp,10));


	}catch(e){
	   alert('error in calcBulidingSellLTCG=' + e);
   }
}

function addCGDeductionsLtcg1(tableId){
	var table = document.getElementById('scheduleCGltcg1');
	var noOfRows = table.rows.length;
	console.log("tableId"+tableId);
	var table2 = document.getElementById(tableId);
	var noOfRows2 = table2.rows.length;



	console.log("noOfRows2"+noOfRows2);


	var temp=parseInt('0',10);

	var exemptionOrDednUs54=parseInt('0',10);

	for (var i = 0; i <noOfRows/14; i++) {

		for(var j = 0; j <noOfRows2-3; j++){
			temp = parseInt(temp) + eval(parseInt(coalesce(document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild['+i+'].exemptionOrDedn['+j+'].amount')[0].value),10));
		}
		return temp;
	}

}

//To calculate  bond sell LTCG
function calcBondSellLTCG(){
	try{
		//Calc deduction
		var totalDedn = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.deductSec48.totalDedn')[0];
		totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.deductSec48.aquisitCost') +
				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.deductSec48.improveCost') +
				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.deductSec48.expOnTrans'));

		//calcBalance
		var balanceCG = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.balanceCG')[0];
		balanceCG.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.fullConsideration') -
				totalDedn.value);

		//gain on Assets
		var capgainonAssets = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.capgainonAssets')[0];
		var exemptionOrDednUs54 = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.exemptionOrDednUs54')[0];
		exemptionOrDednUs54.value = addCGDeductions('ltcgDeduction2');
		if(balanceCG.value > parseInt(0,10)){
			capgainonAssets.value = zeroOrMore(eval(balanceCG.value -
					parseInt(exemptionOrDednUs54.value)));
		} else {
			capgainonAssets.value = balanceCG.value;
		}
	}catch(e){
		alert('error in calcBondSellLTCG=' + e);
	}
}

//To calculate  listed secuirities sell LTCG
function calcListedSecuritiesSellLTCG(cgosIncome){
	try{

		var tab = document.getElementById('scheduleCGltcg3');
		var len = tab.tBodies.length;
		var sum = 0;
		for(var i=0;i<len;i++){

			//Calc deduction
			var totalDedn = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].deductSec48.totalDedn')[0];
			totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].deductSec48.aquisitCost') +
					coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].deductSec48.improveCost') +
					coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].deductSec48.expOnTrans'));

			//calcBalance
			var balanceCG = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].balanceCG')[0];
			balanceCG.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].fullConsideration') -
					totalDedn.value);

			//gain on Assets
			var capgainonAssets = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].capgainonAssets')[0];
			var exemptionOrDednUs54S = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable['+ i +'].exemptionOrDednUs54S')[0];
			exemptionOrDednUs54S.value = addCGDeductions('scheduleCGltcg3_ded' + (i+1));

			if(balanceCG.value > parseInt(0,10)){
				capgainonAssets.value = zeroOrMore(eval(balanceCG.value -
						parseInt(exemptionOrDednUs54S.value)));
			} else {

				capgainonAssets.value = balanceCG.value;
			}

			var section = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable[' + i +  '].sectionCode')[0].value;
			if(section=='22'){
				sum = parseInt(sum) + parseInt(capgainonAssets.value);
			}else if(section=='5ACA1b'){
				cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 = capgainonAssets.value;
			}
		}

		return sum;
	}catch(e){
		alert('error in calcListedSecuritiesSellLTCG=' + e);
	}
}

//To calculate  NRI proviso
function calcNRIProvisoSec48LTCG(){
	try{
		var balanceCG = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRIProvisoSec48.BalanceCG')[0];
		var ltcgWithoutBenefit = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIProvisoSec48.ltcgWithoutBenefit');
		var exemptionOrDednUs54 = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRIProvisoSec48.exemptionOrDednUs54')[0];
		exemptionOrDednUs54.value = addCGDeductions('scheduleCGltcg4_ded1');
		if(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIProvisoSec48.ltcgWithoutBenefit') > parseInt(0, 10)){
			balanceCG.value = zeroOrMore(eval( ltcgWithoutBenefit - exemptionOrDednUs54.value));
		}else{
			balanceCG.value = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIProvisoSec48.ltcgWithoutBenefit');
		}
	}catch(e){
		alert('error in calcNRIProvisoSec48LTCG=' + e);
	}
}

//To calculate unlisted securities sell
function calcUnlistedSecuritiesSellLTCG(cgosIncome){
	//Calc deduction
	try{
		var tab = document.getElementById('stcg10pctTab');
		var len = tab.tBodies.length;
		var sum = 0;
		for(var i=0;i<len;i++){
			var totalDedn = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].deductSec48.totalDedn')[0];
			totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].deductSec48.aquisitCost') +
					coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].deductSec48.improveCost') +
					coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].deductSec48.expOnTrans'));

			//calcBalance
			var balanceCG = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].balanceCG')[0];
			balanceCG.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].fullConsideration') -
					totalDedn.value);

			//gain on Assets
			var capgainonAssets = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].capgainonAssets')[0];
			var exemptionOrDednUs54S = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].exemptionOrDednUs54S')[0];
			exemptionOrDednUs54S.value =  addCGDeductions('stcg10pctTab_ded' + (i+1));


			if(balanceCG.value > parseInt(0,10)){
				capgainonAssets.value = zeroOrMore(eval(balanceCG.value -
						parseInt(exemptionOrDednUs54S.value)));
			} else {
				capgainonAssets.value = balanceCG.value;
			}
			sum = parseInt(sum, 10) + parseInt(capgainonAssets.value, 10);
			var section = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115[' + i +  '].sectionCode')[0].value;
			if(section=='21ciii'){
				cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2 = parseInt(capgainonAssets.value, 10);
			}else if(section=='5AC1c'){
				cgosIncome.cgInc.ltcg.prctg10.sec115AC_1 = parseInt(capgainonAssets.value, 10);
			}else if(section=='5ACA1b'){
				cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 = parseInt(capgainonAssets.value, 10);
			}else if(section=='5ADiii'){
				cgosIncome.cgInc.ltcg.prctg10.sec115AD_3 = parseInt(capgainonAssets.value, 10);
			}
		}
		return sum;
	}catch(e){
		alert('error in calcUnlistedSecuritiesSellLTCG=' + e);
	}
}

//To calculate for LTCG asset
function calcForexAssetLTCG(){
	try{
		var balonSpeciAsset = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.balonSpeciAsset')[0];
		var dednSpecAssetus115 = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.dednSpecAssetus115');
		var saleonSpecAsset = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.saleonSpecAsset');

		if(parseInt(saleonSpecAsset) > parseInt(0, 10)){
			balonSpeciAsset.value = zeroOrMore(eval(parseInt(saleonSpecAsset) -
					parseInt(dednSpecAssetus115)));
		}else{
			balonSpeciAsset.value = saleonSpecAsset;
		}

		var balOtherthanSpecAsset = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.balOtherthanSpecAsset')[0];
		var dednOtherSpecAssetus115 = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.dednOtherSpecAssetus115');
		var saleOtherSpecAsset = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.saleOtherSpecAsset');

		if(parseInt(saleOtherSpecAsset) > parseInt(0, 10)){
			balOtherthanSpecAsset.value = zeroOrMore(eval(parseInt(saleOtherSpecAsset) -
					parseInt(dednOtherSpecAssetus115)));
		}else{
			balOtherthanSpecAsset.value = saleOtherSpecAsset;
		}
	}catch(e){
		alert('error in calcForexAssetLTCG=' + e);
	}
}

//To calculate  other LTCG assets
function calcOthAssetLTCG(){
	try{
	//Calc deduction
    var totalDedn = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.deductSec48.totalDedn')[0];
    totalDedn.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.deductSec48.aquisitCost') +
                           coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.deductSec48.improveCost') +
                           coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.deductSec48.expOnTrans'));

    //calcBalance
    var balanceCG = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.balanceCG')[0];
    balanceCG.value = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.deductSec48.fullConsideration') -
    					   totalDedn.value);

    //gain on Assets
    var capgainonAssets = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.capgainonAssets')[0];
    var exemptionOrDednUs54S = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.exemptionOrDednUs54S')[0];
    exemptionOrDednUs54S.value = addCGDeductions('scheduleCGltcg7');
    if(parseInt(balanceCG.value) > 0){
    capgainonAssets.value = zeroOrMore(eval(balanceCG.value -
    							 parseInt(coalesce(exemptionOrDednUs54S.value))));
    }else{
    	capgainonAssets.value = balanceCG.value;
    }
    }catch(e){
    	alert('error in calcForexAssetLTCG=' + e);
    }
}


//To calculate  lTCG
function calculateLTCG(cgosIncome){
    try{
    	calcBulidingSellLTCG();
    	calcBondSellLTCG();
    	var secSell = calcListedSecuritiesSellLTCG(cgosIncome);
    	calcNRIProvisoSec48LTCG();
    	var sum = calcUnlistedSecuritiesSellLTCG(cgosIncome);
    	calcForexAssetLTCG();
    	calcOthAssetLTCG();


        var totalLTCG = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.totalLTCG')[0];

        totalLTCG.value = eval( coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild.capgainonAssets') +
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.capgainonAssets') +
                				parseInt(secSell) +
                				parseInt(coalesce(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1)) +
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIProvisoSec48.BalanceCG') +
                				parseInt(sum, 10) +
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.stcgUnderDtaa.totAmtLtcgUnderPTI') +
                				parseInt(coalesce(document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.equityOrUnitSec54TypeDebn112.ltcgAssestsB4')[0].value),10)+
                				parseInt(coalesce(document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleOfEquityShare112A.ltcgAssestsB4')[0].value),10)+
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.balonSpeciAsset') +
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.balOtherthanSpecAsset') +
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.capgainonAssets') +
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.stcgUnderDtaa.totAmtStcgUnderDtaa') -
                				coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.ltcgUnderDtaa.totalAmtNotTaxUsDTAALtcg')
                				);
    	cgosIncome.cgInc.ltcg.prctg20.sec112 = eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofLandBuild.capgainonAssets') +
    												coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofBondsDebntr.capgainonAssets') +
    												coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.saleofAssetNA.capgainonAssets')  +
    												coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRIProvisoSec48.BalanceCG')  +
    												coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.stcgUnderDtaa.totAmtStcgUnderDtaa')
    												- setOffWithDtaa('sec112')
    												);

    	console.log("prctg20.sec112"+cgosIncome.cgInc.ltcg.prctg20.sec112);
    	cgosIncome.cgInc.ltcg.prctg10.sec112A = parseInt(coalesce(document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.equityOrUnitSec54TypeDebn112.ltcgAssestsB4')[0].value),10) - setOffWithDtaa('2A');
    	cgosIncome.cgInc.ltcg.prctg10.secPti = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.stcgUnderDtaa.ptiLtcg10');
    	cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP = parseInt(coalesce(document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.saleOfEquityShare112A.ltcgAssestsB4')[0].value),10) - setOffWithDtaa('5ADiiiP');
    	cgosIncome.cgInc.ltcg.prctg20.sec11EA = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.balOtherthanSpecAsset') - setOffWithDtaa('sec11EA');
    	cgosIncome.cgInc.ltcg.prctg10.secProviso = parseInt(secSell) - setOffWithDtaa('secProviso');
    	cgosIncome.cgInc.ltcg.prctg20.secPti = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.stcgUnderDtaa.ptiLtcg20') - setOffWithDtaa('PTI_LTCG20P');




    	cgosIncome.cgInc.ltcg.prctg10.sec115E_b = coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.nRISaleofForeignAsset.balonSpeciAsset')  - setOffWithDtaa('sec115E_b');

        } catch(e) {
        	alert(' exception in calculateLTCG :: '+e)
        }
}

function setOffWithDtaa(sectionCode) {

	var arr = {'B1e':0,'B2e':0,'B3e_112(1)':0,'B3e_115ACA':0,'B4f_112A':0,'B5c':0,'B6e_112(1)(c)':0,'B6e_115AC':0,'B6e_115AD':0,'B7f':0,'B8c':0,'B8f':0,'B9e':0,'B10':0,'B11a':0,'B11b':0};
	var tab = document.getElementById('scheduleLtcgDtaa');
	  var rowCount = tab.rows.length -2;
	  var total = 0;

	  for(var i=0; i<rowCount; i++) {
	    var itemIncluded = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.ltcgUnderDtaa['+ i +'].itemIncluded')[0].value;
	    var amount = document.getElementsByName('scheduleCGPost45.longTermCapGainPost45.ltcgUnderDtaa['+ i +'].amount')[0].value;
	   if(itemIncluded == 'B1e') {
	       arr['B1e'] = parseInt(arr['B1e'],10) +  parseInt(coalesce(amount),10);
	    } else if(itemIncluded == 'B2e') {
		       arr['B2e'] = parseInt(arr['B2e'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B3e_112(1)') {
		       arr['B3e_112(1)'] = parseInt(arr['B3e_112(1)'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B3e_115ACA') {
		       arr['B3e_115ACA'] = parseInt(arr['B3e_115ACA'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B4f_112A') {
		       arr['B4f_112A'] = parseInt(arr['B4f_112A'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B5c') {
		       arr['B5c'] = parseInt(arr['B5c'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B6e_112(1)(c)') {
		       arr['B6e_112(1)(c)'] = parseInt(arr['B6e_112(1)(c)'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B6e_115AC') {
			   arr['B6e_115AC'] = parseInt(arr['B6e_115AC'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B6e_115AD') {
		       arr['B6e_115AD'] = parseInt(arr['B6e_115AD'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B7f') {
		       arr['B7f'] = parseInt(arr['B7f'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B8c') {
		       arr['B8c'] = parseInt(arr['B8c'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B8f') {
		       arr['B8f'] = parseInt(arr['B8f'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B9e') {
		       arr['B9e'] = parseInt(arr['B9e'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B10') {
		       arr['B10'] = parseInt(arr['B10'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B11a') {
		       arr['B11a'] = parseInt(arr['B11a'],10) +  parseInt(coalesce(amount),10);
		} else if(itemIncluded == 'B11b') {
		       arr['B11b'] = parseInt(arr['B11b'],10) +  parseInt(coalesce(amount),10);
		}
	  }

	  if(sectionCode == 'sec112') {
		  total = arr['B1e'] + arr['B2e'] + arr['B9e'] + arr['B5c'] + arr['B10'];
	  } else if(sectionCode == '2A') {
		  total = arr['B4f_112A'];
	  } else if(sectionCode == '5ADiiiP') {
		  total = arr['B7f'];
	  } else if(sectionCode == 'sec11EA') {
		  total = arr['B8f'];
	  } else if(sectionCode == 'PTI_LTCG10P') {
		  total = arr['B11a'];
	  } else if(sectionCode == 'PTI_LTCG20P') {
		  total = arr['B11b'];
	  } else if(sectionCode == 'secProviso') {
		  total = arr['B3e_112(1)'];
	  } else if(sectionCode == 'sec115E_b') {
		  total = arr['B8c'];
	  } else if(sectionCode == 'sec115ACA_1') {
		  total = arr['B3e_115ACA'];
	  } else if(sectionCode == 'sec112_1_c_2') {
		  total = arr['B6e_112(1)(c)'];
	  } else if(sectionCode == 'sec115AC_1') {
		  total = arr['B6e_115AC'];
	  } else if(sectionCode == 'sec115AD_3') {
		  total = arr['B6e_115AD'];
	  }
	  return total;

}

// To setoff CG
function doCGSetOff(cgosIncome){
	populateCGTab(cgosIncome);
	setOffPctg30Loss(cgosIncome);
	setOffPctgArLoss(cgosIncome);
	setOffPctgSDTAALoss(cgosIncome);
	setOffPctg20Loss(cgosIncome);
	setOffPctg15Loss(cgosIncome);
	setOffPctg10Loss(cgosIncome);
	setOffPctgLDTAALoss(cgosIncome);
}


//To setOfff STCG With A7
function setOffSTCGWithA7(cgosIncome) {
	var sec111a = parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a,10);
	var sec115ad_1_b_ii = parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii,10);
	var secPti = parseInt(cgosIncome.cgInc.stcg.prctg15.secPti,10);

	var tab = document.getElementById('scheduleStcgDtaa');
	var rowCount = tab.rows.length - 2;
	var sectionValue;
	var amount;

	for(var i=0; i<rowCount; i++){
		sectionValue = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa['+i+'].itemIncluded')[0].value;
		amount = parseInt(document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa['+i+'].amount')[0].value,10);

		if(sectionValue == 'A2e_111A' || sectionValue == 'A3a'){
			sec111a -= amount;
		} else if(sectionValue == 'A2e_115AD'){
			sec115ad_1_b_ii -= amount;
		} else if(sectionValue == 'A7a'){
			secPti -= amount;
		} else if(sectionValue == 'A4e'){
			cgosIncome.cgInc.stcg.prctg30.sec115AD -= amount;
		} else if(sectionValue == 'A7b'){
			cgosIncome.cgInc.stcg.prctg30.secPti -= amount;
		}else if(sectionValue == 'A1e' || sectionValue == 'A3b' || sectionValue == 'A5e' || sectionValue == 'A6'){
			cgosIncome.cgInc.stcg.prctgAr.stcgApp -= amount;
		}else if(sectionValue == 'A7c'){
			cgosIncome.cgInc.stcg.prctgAr.secPti -= amount;
		}
	}

	cgosIncome.cgInc.stcg.prctg15.sec111a = sec111a;
	cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii = sec115ad_1_b_ii;
	cgosIncome.cgInc.stcg.prctg15.secPti = secPti;
}

//To setOff LTCG With B9
function setOffLTCGWithB9(cgosIncome) {

	var tab = document.getElementById('scheduleStcgDtaa');
	var rowCount = tab.rows.length - 2;
	var sectionValue;
	var amount;
	for(var i=0; i<rowCount; i++){
		sectionValue = document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa['+i+'].itemIncluded')[0].value;
		amount = parseInt(document.getElementsByName('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa['+i+'].amount')[0].value,10);
		if(sectionValue == 'B3e_112(1)'){
			cgosIncome.cgInc.ltcg.prctg10.secProviso -= amount;
		} else if(sectionValue == 'B3e_115ACA'){
			cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 -= amount;
		} else if(sectionValue == 'B6e_112(1)(c)'){
			cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2 -= amount;
		} else if(sectionValue == 'B6e_115AC'){
			cgosIncome.cgInc.ltcg.prctg10.sec115AC_1 -= amount;
		} else if(sectionValue == 'B6e_115AD'){
			cgosIncome.cgInc.ltcg.prctg10.sec115AD_3 -= amount;
		} else if(sectionValue == 'B7f'){
			cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP -= amount;
		} else if(sectionValue == 'B8c'){
			cgosIncome.cgInc.ltcg.prctg10.sec115E_b -= amount;
		} else if(sectionValue == 'B1e' || sectionValue == 'B2e' || sectionValue == 'B5c' || sectionValue == 'B9e' || sectionValue == 'B10'){
			cgosIncome.cgInc.ltcg.prctg20.sec112 -= amount;
		} else if(sectionValue == 'B8f'){
			cgosIncome.cgInc.ltcg.prctg20.sec11EA -= amount;
		}else if(sectionValue == 'B11b'){
			cgosIncome.cgInc.ltcg.prctg20.secPti -= amount;
		}else if(sectionValue == 'B11a'){
			cgosIncome.cgInc.ltcg.prctg10.secPti -= amount;
		}else if(sectionValue == 'B4f_112A'){
			cgosIncome.cgInc.ltcg.prctg10.sec112A -= amount;
		}
	}

}

//To populate CG Tab values
function populateCGTab(cgosIncome){

	setOffSTCGWithA7(cgosIncome);
	setOffLTCGWithB9(cgosIncome);

	var stcg = cgosIncome.cgInc.stcg;
	var prctg15 = cgosIncome.cgInc.stcg.prctg15;
	var prctg15Sum = eval( parseInt(prctg15.sec111a,10) +
							 parseInt(prctg15.sec115ad_1_b_ii,10)+
							 parseInt(prctg15.secPti,10));

	var neg15 = 0;
	if(zeroOrLess(prctg15.sec111a) < 0){
		neg15 = parseInt(neg15) + parseInt(prctg15.sec111a);
		prctg15.sec111a = 0;
	}
	if(zeroOrLess(prctg15.sec115ad_1_b_ii) < 0){
		neg15 = parseInt(neg15) + parseInt(prctg15.sec115ad_1_b_ii);
		prctg15.sec115ad_1_b_ii = 0;
	}
	if(zeroOrLess(prctg15.secPti) < 0){
		neg15 = parseInt(neg15) + parseInt(prctg15.secPti);
		prctg15.secPti = 0;
	}

	if(neg15 < 0){
		var setOff = setOffAgainst115ad_1_b_ii(neg15, cgosIncome);
		neg15 = parseInt(neg15) + parseInt(setOff);
		setOff = setOffAgainst15Pti(neg15, cgosIncome);
		neg15 = parseInt(neg15) + parseInt(setOff);
		setOff = setOffAgainst111a(neg15, cgosIncome);
		neg15 = parseInt(neg15) + parseInt(setOff);
		prctg15.secPti = parseInt(neg15) + parseInt(prctg15.secPti);
	}



	var prctg30 = cgosIncome.cgInc.stcg.prctg30;
	var prctgAr = cgosIncome.cgInc.stcg.prctgAr;
	var neg30 = 0;
	if(zeroOrLess(prctg30.sec115AD) < 0){
		neg30 = parseInt(neg30) + parseInt(prctg30.sec115AD);
		prctg30.sec115AD = 0;
	}
	if(zeroOrLess(prctg30.secPti) < 0){
		neg30 = parseInt(neg30) + parseInt(prctg30.secPti);
		prctg30.secPti = 0;
	}

	if(neg30 < 0){
		var setOff = setOffAgainst115AD(neg30, cgosIncome);
		neg30 = parseInt(neg30) + parseInt(setOff);
		var setOff = setOffAgainst30PTI(neg30, cgosIncome);
		neg30 = parseInt(neg30) + parseInt(setOff);
		prctg30.secPti = parseInt(neg30) + parseInt(prctg30.secPti);
	}

	var negAr = 0;
	if(zeroOrLess(prctgAr.stcgApp) < 0){
		negAr = parseInt(negAr) + parseInt(prctgAr.stcgApp);
		prctgAr.stcgApp= 0;
	}
	if(zeroOrLess(prctgAr.secPti) < 0){
		negAr = parseInt(negAr) + parseInt(prctgAr.secPti);
		prctgAr.secPti = 0;
	}

	if(negAr < 0){
		var setOff = setOffAgainststcgApp(negAr, cgosIncome);
		negAr = parseInt(negAr) + parseInt(setOff);
		var setOff = setOffAgainstArPti(negAr, cgosIncome);
		negAr = parseInt(negAr) + parseInt(setOff);
		prctgAr.secPti = parseInt(negAr) + parseInt(prctgAr.secPti);
	}
	var prctg30Sum = eval( parseInt(prctg30.sec115AD,10) +
			 parseInt(prctg30.secPti,10));
	console.log("prctg30Sum"+prctg30Sum);
	var prctgArSum = eval( parseInt(prctgAr.stcgApp,10) +
			 parseInt(prctgAr.secPti,10));
	console.log("prctgArSum"+prctgArSum);
	console.log("prctg15Sum"+prctg15Sum);

	setProfitLoss(prctg15Sum, 'scheduleCGPost45.currYrLosses.inLossSetOff.stclSetoff15Per', 'scheduleCGPost45.currYrLosses.inStcg15Per.currYearIncome');
	setProfitLoss(prctg30Sum, 'scheduleCGPost45.currYrLosses.inLossSetOff.StclSetoff30Per', 'scheduleCGPost45.currYrLosses.inStcg30Per.currYearIncome');
	setProfitLoss(prctgArSum, 'scheduleCGPost45.currYrLosses.inLossSetOff.StclSetoffAppRate', 'scheduleCGPost45.currYrLosses.inStcgAppRate.currYearIncome');

	//document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncome')[0].value=eval(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.totAmtStcgUnderDtaa'));
	//document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncome')[0].value=eval(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.ltcgUnderDtaa.totAmtLtcgUnderDtaa'));

	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	prctg10.sec115ACA_1 = prctg10.sec115ACA_1 - setOffWithDtaa('sec115ACA_1');
	prctg10.sec112_1_c_2 = prctg10.sec112_1_c_2 - setOffWithDtaa('sec112_1_c_2');
	prctg10.sec115AC_1 = prctg10.sec115AC_1 -  setOffWithDtaa('sec115AC_1');
	prctg10.sec115AD_3 = prctg10.sec115AD_3 - setOffWithDtaa('sec115AD_3');
	prctg10.secPti = prctg10.secPti - setOffWithDtaa('PTI_LTCG10P');

	var prctg10Sum = eval( parseInt(prctg10.secProviso,10) +
							 parseInt(prctg10.sec112_1_c_2,10) +
							 parseInt(prctg10.sec115AC_1,10) +
							 parseInt(prctg10.sec115ACA_1,10) +
							 parseInt(prctg10.sec115AD_3,10) +
							 parseInt(prctg10.sec115ADiiiP,10) +
							 parseInt(prctg10.sec115E_b,10) +
							 parseInt(prctg10.sec112A,10)+
							 parseInt(prctg10.secPti,10));

	var neg10 = 0;

	if(zeroOrLess(prctg10.secProviso) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.secProviso);
		prctg10.secProviso = 0;
	}
	if(zeroOrLess(prctg10.sec112_1_c_2) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.sec112_1_c_2);
		prctg10.sec112_1_c_2 = 0;
	}
	if(zeroOrLess(prctg10.sec115AC_1) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.sec115AC_1);
		prctg10.sec115AC_1 = 0;
	}
	if(zeroOrLess(prctg10.sec115ACA_1) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.sec115ACA_1);
		prctg10.sec115ACA_1 = 0;
	}
	if(zeroOrLess(prctg10.sec115AD_3) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.sec115AD_3);
		prctg10.sec115AD_3 = 0;
	}
	if(zeroOrLess(prctg10.sec115ADiiiP) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.sec115ADiiiP);
		prctg10.sec115ADiiiP = 0;
	}
	if(zeroOrLess(prctg10.sec115E_b) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.sec115E_b);
		prctg10.sec115E_b = 0;
	}
	if(zeroOrLess(prctg10.sec112A) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.sec112A);
		prctg10.sec112A = 0;
	}
	if(zeroOrLess(prctg10.secPti) < 0){
		neg10 = parseInt(neg10) + parseInt(prctg10.secPti);
		prctg10.secPti = 0;
	}

	if(neg10 < 0){
		var setOff = setOffAgainst112_1_c_2(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainst115AC_1(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainst115ACA_1(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainst115AD_3(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainstsec115ADiiiP(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainst115E_b(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainst10Pti(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainstsecProviso(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		setOff = setOffAgainstsec112A(neg10, cgosIncome);
		neg10 = parseInt(neg10) + parseInt(setOff);
		prctg10.sec112_1_c_2 = parseInt(neg10) + parseInt(prctg10.sec112_1_c_2);
	}


	var prctg20 = cgosIncome.cgInc.ltcg.prctg20;
	var prctg20Sum = eval( parseInt(prctg20.sec112,10) +
							 parseInt(prctg20.sec11EA,10)+
							 parseInt(prctg20.secPti,10));

	var neg20 = 0;
	if(zeroOrLess(prctg20.sec112) < 0){
		neg20 = parseInt(neg20) + parseInt(prctg20.sec112);
		prctg20.sec112 = 0;
	}
	if(zeroOrLess(prctg20.sec11EA) < 0){
		neg20 = parseInt(neg20) + parseInt(prctg20.sec11EA);
		prctg20.sec11EA = 0;
	}
	if(zeroOrLess(prctg20.secPti) < 0){
		neg20 = parseInt(neg20) + parseInt(prctg20.secPti);
		prctg20.secPti = 0;
	}

	if(neg20 < 0){
		var setOff =setOffAgainst115Ea(neg20, cgosIncome);
		neg20 = parseInt(neg20) + parseInt(setOff);
		setOff = setOffAgainst20Pti(neg20, cgosIncome);
		neg20 = parseInt(neg20) + parseInt(setOff);
		setOff = setOffAgainst112(neg20, cgosIncome);
		neg20 = parseInt(neg20) + parseInt(setOff);
		prctg20.secPti = parseInt(neg20) + parseInt(prctg20.secPti);
	}

	setProfitLoss(prctg10Sum, 'scheduleCGPost45.currYrLosses.inLossSetOff.LtclSetOff10Per', 'scheduleCGPost45.currYrLosses.inLtcg10Per.currYearIncome');
	setProfitLoss(prctg20Sum, 'scheduleCGPost45.currYrLosses.inLossSetOff.LtclSetOff20Per', 'scheduleCGPost45.currYrLosses.inLtcg20Per.currYearIncome');

	setProfitLoss(coalesceSetRet('scheduleCGPost45.shortTermCapGainPost45.stcgUnderDtaa.totAmtStcgUnderDtaa'), 'scheduleCGPost45.currYrLosses.inLossSetOff.StclSetoffDtaaRate', 'scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncome');
	setProfitLoss(coalesceSetRet('scheduleCGPost45.longTermCapGainPost45.ltcgUnderDtaa.totAmtLtcgUnderDtaa'), 'scheduleCGPost45.currYrLosses.inLossSetOff.LtclSetOffDtaaRate', 'scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncome');


}



//To setOff 30 Percentage Loss
function setOffPctg30Loss(cgosIncome){
	var inStcgAppRate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgAppRate.stclSetoff30Per')[0];
	var inStcg15Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg15Per.stclSetoff30Per')[0];
	var inLtcg20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg20Per.StclSetoff30Per')[0];
	var inLtcg10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoff30Per')[0];
	var inStcgDTAARate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.stclSetoff30Per')[0];
	var inLtcgDTAARates = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoff30Per')[0];

	var amtSetOff = 0;

	var prctg30 = cgosIncome.cgInc.stcg.prctg30;
	var prctg30Sum = eval( parseInt(prctg30.sec115AD,10) +
							 parseInt(prctg30.secPti,10));

	console.log("setOffPctg30Loss"+prctg30Sum);

	amtSetOff = setOffAgainstAr(parseInt(prctg30Sum, 10), cgosIncome);
	prctg30Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg30Sum, 10));
	console.log("setOffAgainstAr"+amtSetOff);
	console.log("setOffAgainstArprctg30Sum"+prctg30Sum);
	inStcgAppRate.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst20(parseInt(prctg30Sum, 10), cgosIncome);
	prctg30Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg30Sum, 10));
	inLtcg20Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst15(parseInt(prctg30Sum, 10), cgosIncome);
	prctg30Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg30Sum, 10));
	inStcg15Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst10(parseInt(prctg30Sum, 10), cgosIncome);
	prctg30Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg30Sum, 10));
	inLtcg10Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainstStcgDr(parseInt(prctg30Sum, 10));
	prctg30Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg30Sum, 10));
	inStcgDTAARate.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainstLtcgDr(parseInt(prctg30Sum, 10));
	prctg30Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg30Sum, 10));
	inLtcgDTAARates.value = Math.abs(parseInt(amtSetOff, 10));
}

//To setOff Percentage Applicable rates Loss
function setOffPctgArLoss(cgosIncome){
	var inStcg30Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg30Per.stclSetoffAppRate')[0];
	var inStcg15Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg15Per.StclSetoffAppRate')[0];
	var inLtcg20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg20Per.StclSetoffAppRate')[0];
	var inLtcg10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoffAppRate')[0];
	var inStcgDTAARate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.stclSetoffAppRate')[0];
	var inLtcgDTAARates = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoffAppRate')[0];

	var amtSetOff = 0;

	var prctgAr = cgosIncome.cgInc.stcg.prctgAr;
	var prctgArSum = eval( parseInt(prctgAr.stcgApp,10) +
							 parseInt(prctgAr.secPti,10));

	console.log("prctgArSum"+prctgArSum);

	amtSetOff = setOffAgainst30(parseInt(prctgArSum, 10), cgosIncome);
	prctgArSum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctgArSum, 10));
	console.log("inStcg30Per"+amtSetOff);
	inStcg30Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst20(parseInt(prctgArSum, 10), cgosIncome);
	prctgArSum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctgArSum, 10));
	console.log("inLtcg20Per"+amtSetOff);
	inLtcg20Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst15(parseInt(prctgArSum, 10), cgosIncome);
	prctgArSum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctgArSum, 10));
	inStcg15Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst10(parseInt(prctgArSum, 10), cgosIncome);
	prctgArSum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctgArSum, 10));
	inLtcg10Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainstStcgDr(parseInt(prctgArSum, 10));
	prctgArSum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctgArSum, 10));
	inStcgDTAARate.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainstLtcgDr(parseInt(prctgArSum, 10));
	prctgArSum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctgArSum, 10));
	inLtcgDTAARates.value = Math.abs(parseInt(amtSetOff, 10));
}


//To setOff Percentage STCG DTAA rates Loss
function setOffPctgSDTAALoss(cgosIncome){
	var inStcg15Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg15Per.StclSetoffDtaaRate')[0];
	var inStcg30Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg30Per.StclSetoffDtaaRate')[0];
	var inLtcg20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg20Per.stclSetoffDtaaRate')[0];
	var inLtcg10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoffDtaaRate')[0];
	var inStcgAppRate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgAppRate.stclSetoffDtaaRate')[0];
	var inLtcgDTAARates = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoffDtaaRate')[0];
	var inStcgDTAARatesVal = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden')[0];

	var amtSetOff = 0;

	console.log("inStcgAppRateVal"+inStcgDTAARatesVal.value);

	amtSetOff = setOffAgainst30(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10), cgosIncome);
	console.log("setOffAgainst30amtSetOff"+amtSetOff);
	inStcgDTAARatesVal.value = eval( parseInt(amtSetOff, 10) + parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10));
	inStcg30Per.value = Math.abs(parseInt(amtSetOff, 10));
	console.log("inStcgDTAARatesVal"+Math.abs(parseInt(amtSetOff, 10)));

	amtSetOff = setOffAgainstAr(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10), cgosIncome);
	inStcgDTAARatesVal.value = eval( parseInt(amtSetOff, 10) + parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10));
	inStcgAppRate.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst20(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10), cgosIncome);
	inStcgDTAARatesVal.value= eval( parseInt(amtSetOff, 10) +
										  parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10));
	inLtcg20Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst15(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10), cgosIncome);
	inStcgDTAARatesVal.value = eval( parseInt(amtSetOff, 10) +
										  parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10));
	inStcg15Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst10(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10), cgosIncome);
	inStcgDTAARatesVal.value = eval( parseInt(amtSetOff, 10) +
										  parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10));
	inLtcg10Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainstLtcgDr(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10));
	inStcgDTAARatesVal.value = eval( parseInt(amtSetOff, 10) +
										  parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden'), 10));
	inLtcgDTAARates.value = Math.abs(parseInt(amtSetOff, 10));
}


//To setOff Percentage LTCG DTAA rates Loss
function setOffPctgLDTAALoss(cgosIncome){
	var inLtcg20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg20Per.ltclSetOffDtaaRate')[0];
	var inLtcg10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg10Per.ltclSetOffDtaaRate')[0];
	var inStcgDTAARatesVal = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden')[0];

	var amtSetOff = 0;

	amtSetOff = setOffAgainst20(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden'), 10), cgosIncome);
	inStcgDTAARatesVal.value = eval( parseInt(amtSetOff, 10) +
										  parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden'), 10));
	inLtcg20Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst10(parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden'), 10), cgosIncome);
	inStcgDTAARatesVal.value = eval( parseInt(amtSetOff, 10) +
										  parseInt(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden'), 10));
	inLtcg10Per.value = Math.abs(parseInt(amtSetOff, 10));
}

//To setOff Percentage 15 Loss
function setOffPctg15Loss(cgosIncome){
	var inStcg30Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg30Per.stclSetoff15Per')[0];
	var inStcgAppRate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgAppRate.stclSetoff15Per')[0];
	var inLtcg20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg20Per.StclSetoff15Per')[0];
	var inLtcg10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoff15Per')[0];
	var inStcgDTAARate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.stclSetoff15Per')[0];
	var inLtcgDTAARates = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoff15Per')[0];

	var amtSetOff = 0;
	var totalSetOff = 0;

	var prctg15 = cgosIncome.cgInc.stcg.prctg15;
	var prctg15Sum = eval( parseInt(prctg15.sec111a,10) +
							 parseInt(prctg15.sec115ad_1_b_ii,10)+
							 parseInt(prctg15.secPti,10));

	amtSetOff = setOffAgainst30(parseInt(prctg15Sum, 10), cgosIncome);
	prctg15Sum = eval( parseInt(amtSetOff, 10) +
					   parseInt(prctg15Sum, 10));
	totalSetOff = amtSetOff;
	inStcg30Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainstAr(parseInt(prctg15Sum, 10), cgosIncome);
	prctg15Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg15Sum, 10));
	totalSetOff = parseInt(totalSetOff) + parseInt(amtSetOff);
	inStcgAppRate.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst20(parseInt(prctg15Sum, 10), cgosIncome);
	prctg15Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg15Sum, 10));
	totalSetOff = parseInt(totalSetOff) + parseInt(amtSetOff);
	inLtcg20Per.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainst10(parseInt(prctg15Sum, 10), cgosIncome);
	prctg15Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg15Sum, 10));
	totalSetOff = parseInt(totalSetOff) + parseInt(amtSetOff);
	inLtcg10Per.value = Math.abs(parseInt(amtSetOff, 10));

	if(parseInt(totalSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10)) > parseInt(totalSetOff, 10)){
		cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii = parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10) +
												parseInt(totalSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(totalSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10) < 0){
		amtSetOff = parseInt(totalSetOff, 10) +
					parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10) ;
		cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii = 0;
	}

	if(parseInt(totalSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10)) > parseInt(totalSetOff, 10)){
		cgosIncome.cgInc.stcg.prctg15.secPti = parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10) +
												parseInt(totalSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(totalSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10) < 0){
		amtSetOff = parseInt(totalSetOff, 10) +
			parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10) ;
		cgosIncome.cgInc.stcg.prctg15.secPti = 0;
	}

	if(parseInt(totalSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10)) > parseInt(totalSetOff, 10)){
		cgosIncome.cgInc.stcg.prctg15.sec111a = parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10) +
												parseInt(totalSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(totalSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10) < 0){
		amtSetOff = parseInt(totalSetOff, 10) +
			parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10) ;
		cgosIncome.cgInc.stcg.prctg15.sec111a = 0;
	}


	amtSetOff = setOffAgainstStcgDr(parseInt(prctg15Sum, 10));
	prctg15Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg15Sum, 10));
	totalSetOff = parseInt(totalSetOff) + parseInt(amtSetOff);
	inStcgDTAARate.value = Math.abs(parseInt(amtSetOff, 10));

	amtSetOff = setOffAgainstLtcgDr(prctg15Sum, 10);
	prctg15Sum = eval( parseInt(amtSetOff, 10) +
										  parseInt(prctg15Sum, 10));
	totalSetOff = parseInt(totalSetOff) + parseInt(amtSetOff);
	inLtcgDTAARates.value = Math.abs(parseInt(amtSetOff, 10));

}

//To setOff Percentage 20 Loss
function setOffPctg20Loss(cgosIncome){
	var inLtcg10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg10Per.ltclSetOff20Per')[0];
	var inLtcgDTAARates = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.LtclSetOff20Per')[0];

	var amtSetOff = 0;

	var prctg20 = cgosIncome.cgInc.ltcg.prctg20;
	var prctg20Sum = eval( parseInt(prctg20.sec112,10) +
							 parseInt(prctg20.sec11EA,10)+
							 parseInt(prctg20.secPti,10));

	amtSetOff = setOffAgainst10(parseInt(prctg20Sum, 10), cgosIncome);

	inLtcg10Per.value = Math.abs(parseInt(amtSetOff, 10));

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg20.sec112 = parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
			parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10) ;
		cgosIncome.cgInc.ltcg.prctg20.sec112 = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg20.sec11EA = parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10) ;
		cgosIncome.cgInc.ltcg.prctg20.sec11EA = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg20.secPti = parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10) ;
		cgosIncome.cgInc.ltcg.prctg20.secPti = 0;
	}

	prctg20Sum = eval( parseInt(prctg20.sec112,10) +
			 parseInt(prctg20.sec11EA,10)+
			 parseInt(prctg20.secPti,10));
	amtSetOff = setOffAgainstLtcgDr(parseInt(prctg20Sum, 10));
	inLtcgDTAARates.value = Math.abs(parseInt(amtSetOff, 10));
}

//To setOff Percentage 10 Loss
function setOffPctg10Loss(cgosIncome){
	var inLtcg20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg20Per.LtclSetOff10Per')[0];
	var inLtcgDTAARates = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.LtclSetOff10Per')[0];

	var amtSetOff = 0;


	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = eval( parseInt(prctg10.secProviso,10) +
							 parseInt(prctg10.sec112_1_c_2,10) +
							 parseInt(prctg10.sec115AC_1,10) +
							 parseInt(prctg10.sec115ACA_1,10) +
							 parseInt(prctg10.sec115AD_3,10) +
							 parseInt(prctg10.sec115ADiiiP,10) +
							 parseInt(prctg10.sec115E_b,10) +
							 parseInt(prctg10.sec112A,10) +
							 parseInt(prctg10.secPti,10));

	amtSetOff = setOffAgainst20(parseInt(prctg10Sum, 10), cgosIncome);

	inLtcg20Per.value = Math.abs(parseInt(amtSetOff, 10));

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.secProviso = parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.secProviso = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2 = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.sec115AC_1 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.sec115AC_1 = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.sec115AD_3 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.sec115AD_3 = 0;
	}


	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.sec115E_b = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.sec115E_b = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.sec112A = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.sec112A = 0;
	}

	if(parseInt(amtSetOff, 10) >= 0 && Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10)) > parseInt(amtSetOff, 10)){
		cgosIncome.cgInc.ltcg.prctg10.secPti = parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10) +
												parseInt(amtSetOff, 10);
		amtSetOff = 0;
	}else if(parseInt(amtSetOff, 10) >= 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10) < 0){
		amtSetOff = parseInt(amtSetOff, 10) +
					parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10) ;
		cgosIncome.cgInc.ltcg.prctg10.secPti = 0;
	}

	prctg10Sum = eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10));
	console.log("prctg10Sum"+prctg10Sum);
	amtSetOff = setOffAgainstLtcgDr(parseInt(prctg10Sum, 10));
	inLtcgDTAARates.value = Math.abs(parseInt(amtSetOff, 10));

	calcCYCgRemaining(cgosIncome);
	calcTotalSetOffs();
	calcLossRemaining(cgosIncome);

}

//To calculate Cg Remaining income
function calcCYCgRemaining(cgosIncome){
	var inStcg15Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg15Per.CurrYrLosSetOff')[0];
	var inStcg30Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcg30Per.currYrLosSetOff')[0];
	var inStcgAppRate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgAppRate.currYrLosSetOff')[0];
	var inLtcg10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg10Per.currYrLosSetOff')[0];
	var inLtcg20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcg20Per.CurrYrLosSetOff')[0];
	var inStcgDTAARate = document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYrLosSetOff')[0];
	var inLtcgDTAARates = document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.CurrYrLosSetOff')[0];
	if(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden')>0){
		inStcgDTAARate.value=coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden');
	}else{
		inStcgDTAARate.value=parseInt('0');
	}
	if(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden')>0){
		inLtcgDTAARates.value=coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden');
	}else{
		inLtcgDTAARates.value=parseInt('0');
	}



	var prctg15 = cgosIncome.cgInc.stcg.prctg15;
	var prctg15Sum = eval( parseInt(prctg15.sec111a,10) +
							 parseInt(prctg15.sec115ad_1_b_ii,10)+
							 parseInt(prctg15.secPti,10));
	inStcg15Per.value = zeroOrMore(prctg15Sum);

	var prctg30 = cgosIncome.cgInc.stcg.prctg30;
	var prctg30Sum = eval( parseInt(prctg30.sec115AD,10) +
							 parseInt(prctg30.secPti,10));

	console.log("prctg30SuminStcg30Per"+prctg30Sum);

	inStcg30Per.value = zeroOrMore(prctg30Sum);

	var prctgAr = cgosIncome.cgInc.stcg.prctgAr;
	var prctgArSum = eval( parseInt(prctgAr.stcgApp,10) +
							 parseInt(prctgAr.secPti,10));

	inStcgAppRate.value = zeroOrMore(prctgArSum);

	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = eval( parseInt(prctg10.secProviso,10) +
							 parseInt(prctg10.sec112_1_c_2,10) +
							 parseInt(prctg10.sec115AC_1,10) +
							 parseInt(prctg10.sec115ACA_1,10) +
							 parseInt(prctg10.sec115AD_3,10) +
							 parseInt(prctg10.sec115ADiiiP,10) +
							 parseInt(prctg10.sec115E_b,10) +
							 parseInt(prctg10.sec112A,10)+
							 parseInt(prctg10.secPti,10));


	inLtcg10Per.value = zeroOrMore(prctg10Sum-coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg10Per.ltclSetOffDtaaRate'));

	var prctg20 = cgosIncome.cgInc.ltcg.prctg20;
	var prctg20Sum = eval( parseInt(prctg20.sec112,10) +
							 parseInt(prctg20.sec11EA,10)+
							 parseInt(prctg20.secPti,10));

	inLtcg20Per.value = zeroOrMore(prctg20Sum-coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg20Per.ltclSetOffDtaaRate'));
}

//To calculate Total SetOffs
function calcTotalSetOffs(){
	var stclSetoff15Per = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoff15Per')[0];
	var stclSetoff30Per = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoff30Per')[0];
	var stclSetoffAppRate = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoffAppRate')[0];
	var ltclSetOff10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.ltclSetOff10Per')[0];
	var ltclSetOff20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.ltclSetOff20Per')[0];
	var stclSetoffDtaaRate = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoffDtaaRate')[0];
	var ltclSetoffDtaaRate = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.ltclSetOffDtaaRate')[0];

	ltclSetOff20Per.value = eval(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg10Per.ltclSetOff20Per') +
			 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.LtclSetOff20Per'));

	ltclSetOff10Per.value = eval(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg20Per.LtclSetOff10Per') +
			 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.LtclSetOff10Per'));

	stclSetoffAppRate.value = eval(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcg15Per.StclSetoffAppRate') +
			 coalesceSetRet('scheduleCGPost45.currYrLosses.inStcg30Per.stclSetoffAppRate') +
			 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoffAppRate') +
			 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg20Per.StclSetoffAppRate') +
			 coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.stclSetoffAppRate') +
			 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoffAppRate'));

	stclSetoff30Per.value = eval(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcg15Per.stclSetoff30Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgAppRate.stclSetoff30Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoff30Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg20Per.StclSetoff30Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.stclSetoff30Per')+
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoff30Per'));

	stclSetoff15Per.value = eval(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcg30Per.stclSetoff15Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgAppRate.stclSetoff15Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoff15Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg20Per.StclSetoff15Per') +
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgDTAARate.stclSetoff15Per')+
				 coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoff15Per'));
	stclSetoffDtaaRate.value = eval(coalesceSetRet('scheduleCGPost45.currYrLosses.inStcg15Per.StclSetoffDtaaRate') +
									coalesceSetRet('scheduleCGPost45.currYrLosses.inStcg30Per.StclSetoffDtaaRate') +
									coalesceSetRet('scheduleCGPost45.currYrLosses.inStcgAppRate.stclSetoffDtaaRate') +
									coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg10Per.stclSetoffDtaaRate') +
									coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg20Per.stclSetoffDtaaRate') +
									coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcgDTAARates.StclSetoffDtaaRate'));

	ltclSetoffDtaaRate.value = eval(coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg10Per.ltclSetOffDtaaRate') +
									coalesceSetRet('scheduleCGPost45.currYrLosses.inLtcg20Per.ltclSetOffDtaaRate'));

}

//To calculate Loss Remaining
function calcLossRemaining(cgosIncome){
	var stclSetoff15Per = document.getElementsByName('scheduleCGPost45.currYrLosses.lossRemainSetOff.stclSetoff15Per')[0];
	var stclSetoff30Per = document.getElementsByName('scheduleCGPost45.currYrLosses.lossRemainSetOff.stclSetoff30Per')[0];
	var stclSetoffAppRate = document.getElementsByName('scheduleCGPost45.currYrLosses.lossRemainSetOff.stclSetoffAppRate')[0];
	var ltclSetOff10Per = document.getElementsByName('scheduleCGPost45.currYrLosses.lossRemainSetOff.ltclSetOff10Per')[0];
	var ltclSetOff20Per = document.getElementsByName('scheduleCGPost45.currYrLosses.lossRemainSetOff.ltclSetOff20Per')[0];
	var stclSetoffDtaaRate= document.getElementsByName('scheduleCGPost45.currYrLosses.lossRemainSetOff.stclSetoffDtaaRate')[0];
	var ltclSetOffDtaaRate= document.getElementsByName('scheduleCGPost45.currYrLosses.lossRemainSetOff.ltclSetOffDtaaRate')[0];

	var stclSetoff15PerLoss = document.getElementsByName('scheduleCGPost45.currYrLosses.inLossSetOff.stclSetoff15Per')[0];
	var stclSetoff30PerLoss = document.getElementsByName('scheduleCGPost45.currYrLosses.inLossSetOff.StclSetoff30Per')[0];
	var stclSetoffAppRateLoss = document.getElementsByName('scheduleCGPost45.currYrLosses.inLossSetOff.StclSetoffAppRate')[0];
	var ltclSetoff10PerLoss = document.getElementsByName('scheduleCGPost45.currYrLosses.inLossSetOff.LtclSetOff10Per')[0];
	var ltclSetoff20PerLoss = document.getElementsByName('scheduleCGPost45.currYrLosses.inLossSetOff.LtclSetOff20Per')[0];
	var stclSetoffDtaaRateLoss = document.getElementsByName('scheduleCGPost45.currYrLosses.inLossSetOff.StclSetoffDtaaRate')[0];
	var ltclSetoffDtaaRateLoss = document.getElementsByName('scheduleCGPost45.currYrLosses.inLossSetOff.LtclSetOffDtaaRate')[0];


	var stclSetoff15PerTot = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoff15Per')[0];
	var stclSetoff30PerTot = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoff30Per')[0];
	var stclSetoffAppRateTot = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoffAppRate')[0];
	var ltclSetOff10PerTot = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.ltclSetOff10Per')[0];
	var ltclSetOff20PerTot = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.ltclSetOff20Per')[0];
	var stclSetoffDtaaRateTot = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.stclSetoffDtaaRate')[0];
	var ltclSetoffDtaaRateTot = document.getElementsByName('scheduleCGPost45.currYrLosses.totLossSetOff.ltclSetOffDtaaRate')[0];

	stclSetoff15Per.value = zeroOrMore(parseInt(stclSetoff15PerLoss.value,10)-parseInt(stclSetoff15PerTot.value,10));

	stclSetoff30Per.value = zeroOrMore(parseInt(stclSetoff30PerLoss.value,10)-parseInt(stclSetoff30PerTot.value,10));

	stclSetoffAppRate.value = zeroOrMore(parseInt(stclSetoffAppRateLoss.value,10)-parseInt(stclSetoffAppRateTot.value,10));


	ltclSetOff10Per.value = zeroOrMore(parseInt(ltclSetoff10PerLoss.value,10)-parseInt(ltclSetOff10PerTot.value,10));

	ltclSetOff20Per.value = zeroOrMore(parseInt(ltclSetoff20PerLoss.value,10)-parseInt(ltclSetOff20PerTot.value,10));

	stclSetoffDtaaRate.value = zeroOrMore(parseInt(stclSetoffDtaaRateLoss.value,10)-parseInt(stclSetoffDtaaRateTot.value,10));
	ltclSetOffDtaaRate.value = zeroOrMore(parseInt(ltclSetoffDtaaRateLoss.value,10)-parseInt(ltclSetoffDtaaRateTot.value,10));
}

//To setOff Against applicable rate
function setOffAgainstAr(value, cgosIncome){
	var amtSetOffstcgApp = 0;
	var amtSetOffArPti = 0;
	if(value<0){


		console.log("value"+value);
		amtSetOffstcgApp = setOffAgainststcgApp(value, cgosIncome);
		console.log("amtSetOffstcgApp"+amtSetOffstcgApp);
		amtSetOffArPti = setOffAgainstArPti(value + amtSetOffstcgApp, cgosIncome);
		console.log("amtSetOffArPti"+amtSetOffArPti);

	}
	return parseInt(amtSetOffstcgApp, 10) + parseInt(amtSetOffArPti, 10);
}

//To setOff Against STCG DTAA rate
function setOffAgainstStcgDr(value){
	var stcgDtaa=document.getElementsByName('scheduleCGPost45.currYrLosses.inStcgDTAARate.currYearIncomeHidden')[0];
	var amtSetOff = 0;
	console.log("stcgDtaa"+stcgDtaa.value);
	if(parseInt(value, 10) < 0 && parseInt(stcgDtaa.value, 10) > 0){
		if(parseInt(stcgDtaa.value, 10) >= Math.abs(parseInt(value, 10))){
			stcgDtaa.value = eval( parseInt(stcgDtaa.value, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(stcgDtaa.value, 10));
			stcgDtaa.value = 0;
		}
	}
	console.log("setOffAgainstStcgDramtSetOff"+amtSetOff);
	return amtSetOff;
}

//To setOff Against LTCG DTAA rate
function setOffAgainstLtcgDr(value){
	var stcgDtaa=document.getElementsByName('scheduleCGPost45.currYrLosses.inLtcgDTAARates.currYearIncomeHidden')[0];
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(stcgDtaa.value, 10) > 0){
		if(parseInt(stcgDtaa.value, 10) >= Math.abs(parseInt(value, 10))){
			stcgDtaa.value = eval( parseInt(stcgDtaa.value, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(stcgDtaa.value, 10));
			stcgDtaa.value = 0;
		}
	}

	return amtSetOff;
}

//To setOff Against percent 30
function setOffAgainst30(value, cgosIncome){
	try{
	var amtSetOff115AD = 0;
	var amtSetOffPti = 0;
	if(value<0){
		console.log("value"+value);
		amtSetOff115AD = setOffAgainst115AD(value, cgosIncome);
		console.log("amtSetOff115AD"+amtSetOff115AD);
		amtSetOffPti = setOffAgainst30PTI(value + amtSetOff115AD, cgosIncome);
		console.log("amtSetOffPti"+amtSetOffPti);

	}
	return parseInt(amtSetOff115AD, 10) + parseInt(amtSetOffPti, 10);
	}catch(e){
		alert(e);
	}
}

//To setOff Against percent 15
function setOffAgainst15(value, cgosIncome){

	var amtSetOff111a = 0;
	var amtSetOff115ad_1_b_ii = 0;
	var amtSetOff15Pti = 0;
	var amtSetOff = 0;
	if(value<0){

		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst115ad_1_b_ii(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst15Pti(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst111a(value + amtSetOff, cgosIncome), 10));

	}
	return parseInt(amtSetOff, 10);

}

//To setOff Against percent 20
function setOffAgainst20(value, cgosIncome){
	var amtSetOff112 = 0;
	var amtSetOff115ea = 0;
	var amtSetOff20Pti = 0;
	var amtSetOff = 0;
	if(value<0){

		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst115Ea(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst20Pti(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst112(value + amtSetOff, cgosIncome), 10));

	}
	return parseInt(amtSetOff, 10);
}

//To setOff Against percent 10
function setOffAgainst10(value, cgosIncome){
	var amtSetOff = 0;
	if(value < 0){

		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst112_1_c_2(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst115AC_1(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst115ACA_1(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst115AD_3(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainstsec115ADiiiP(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst115E_b(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainst10Pti(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainstsecProviso(value + amtSetOff, cgosIncome), 10));
		amtSetOff = eval(parseInt(amtSetOff, 10) + parseInt(setOffAgainstsec112A(value + amtSetOff, cgosIncome), 10));
	}
	return amtSetOff;
}


//To setOff Against section 115AD
function setOffAgainst115AD(value, cgosIncome){


	var prctg30 = cgosIncome.cgInc.stcg.prctg30;
	var prctg30Sum = eval( parseInt(prctg30.sec115AD,10) +
							 parseInt(prctg30.secPti,10));

	var amtSetOff = 0;
	console.log("setOffAgainst115ADValue"+value);
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.stcg.prctg30.sec115AD, 10) > 0){
		if(parseInt(cgosIncome.cgInc.stcg.prctg30.sec115AD, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.stcg.prctg30.sec115AD = eval( parseInt(cgosIncome.cgInc.stcg.prctg30.sec115AD, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
			console.log("setOffAgainst115AamtSetOff"+amtSetOff);
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg30.sec115AD, 10));
			cgosIncome.cgInc.stcg.prctg30.sec115AD = 0;
			console.log("setOffAgainst115sec115AD"+amtSetOff);
		}
		if(parseInt(amtSetOff) > parseInt(prctg30Sum)){
			cgosIncome.cgInc.stcg.prctg30.sec115AD = parseInt(cgosIncome.cgInc.stcg.prctg30.sec115AD) + parseInt(amtSetOff) - parseInt(prctg30Sum);
			amtSetOff = zeroOrMore(parseInt(prctg30Sum));
			console.log("prctg30Sum"+prctg30Sum);
			console.log("setOffAgainst115prctg30Sum"+amtSetOff);
		}
	}
	console.log("setOffAgainst115AD"+amtSetOff);

	return amtSetOff;
}


//To setOff Against section PTI
function setOffAgainst30PTI(value, cgosIncome){

	try{


	var prctg30 = cgosIncome.cgInc.stcg.prctg30;
	var prctg30Sum = eval( parseInt(prctg30.sec115AD,10) +
							 parseInt(prctg30.secPti,10));

	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.stcg.prctg30.secPti, 10) > 0){
		if(parseInt(cgosIncome.cgInc.stcg.prctg30.secPti, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.stcg.prctg30.secPti = eval( parseInt(cgosIncome.cgInc.stcg.prctg30.secPti, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg30.secPti, 10));
			cgosIncome.cgInc.stcg.prctg30.secPti = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg30Sum)){
			cgosIncome.cgInc.stcg.prctg30.secPti = parseInt(cgosIncome.cgInc.stcg.prctg30.secPti) + parseInt(amtSetOff) - parseInt(prctg30Sum);
			amtSetOff = zeroOrMore(parseInt(prctg30Sum));
		}
	}

	return amtSetOff;
	}catch(e){
		alert(e);
	}
}


//To setOff Against section stcgApp
function setOffAgainststcgApp(value, cgosIncome){


	var prctgAr = cgosIncome.cgInc.stcg.prctgAr;
	var prctgArSum = eval( parseInt(prctgAr.stcgApp,10) +
							 parseInt(prctgAr.secPti,10));

	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.stcg.prctgAr.stcgApp, 10) > 0){
		if(parseInt(cgosIncome.cgInc.stcg.prctgAr.stcgApp, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.stcg.prctgAr.stcgApp = eval( parseInt(cgosIncome.cgInc.stcg.prctgAr.stcgApp, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
			console.log("prctgAr.stcgApp"+amtSetOff);
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.stcg.prctgAr.stcgApp, 10));
			cgosIncome.cgInc.stcg.prctgAr.stcgApp = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctgArSum)){
			cgosIncome.cgInc.stcg.prctgAr.stcgApp = parseInt(cgosIncome.cgInc.stcg.prctgAr.stcgApp) + parseInt(amtSetOff) - parseInt(prctgArSum);
			amtSetOff = zeroOrMore(parseInt(prctgArSum));
			console.log("prctgArprctgArSum"+amtSetOff);
		}
	}

	console.log("setOffAgainststcgApp"+amtSetOff);

	return amtSetOff;
}


//To setOff Against section PTI
function setOffAgainstArPti(value, cgosIncome){


	var prctgAr = cgosIncome.cgInc.stcg.prctgAr;
	var prctgArSum = eval( parseInt(prctgAr.stcgApp,10) +
							 parseInt(prctgAr.secPti,10));

	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.stcg.prctgAr.secPti, 10) > 0){
		if(parseInt(cgosIncome.cgInc.stcg.prctgAr.secPti, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.stcg.prctgAr.secPti = eval( parseInt(cgosIncome.cgInc.stcg.prctgAr.secPti, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.stcg.prctgAr.secPti, 10));
			cgosIncome.cgInc.stcg.prctgAr.secPti = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctgArSum)){
			cgosIncome.cgInc.stcg.prctgAr.secPti = parseInt(cgosIncome.cgInc.stcg.prctgAr.secPti) + parseInt(amtSetOff) - parseInt(prctgArSum);
			amtSetOff = zeroOrMore(parseInt(prctgArSum));
		}
	}

	return amtSetOff;
}



//To setOff Against section 111a
function setOffAgainst111a(value, cgosIncome){


	var prctg15 = cgosIncome.cgInc.stcg.prctg15;
	var prctg15Sum = eval( parseInt(prctg15.sec111a,10) +
							 parseInt(prctg15.sec115ad_1_b_ii,10)+
							 parseInt(prctg15.secPti,10));

	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10) > 0){
		if(parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.stcg.prctg15.sec111a = eval( parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a, 10));
			cgosIncome.cgInc.stcg.prctg15.sec111a = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg15Sum)){
			cgosIncome.cgInc.stcg.prctg15.sec111a = parseInt(cgosIncome.cgInc.stcg.prctg15.sec111a) + parseInt(amtSetOff) - parseInt(prctg15Sum);
			amtSetOff = zeroOrMore(parseInt(prctg15Sum));
		}
	}

	return amtSetOff;
}

//To setOff Against section 115ad_1_b_ii
function setOffAgainst115ad_1_b_ii(value, cgosIncome){


	var prctg15 = cgosIncome.cgInc.stcg.prctg15;
	var prctg15Sum = eval( parseInt(prctg15.sec111a,10) +
							 parseInt(prctg15.sec115ad_1_b_ii,10) +
							 parseInt(prctg15.secPti,10));

	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10) > 0){
		if(parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii = eval( parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii, 10));
			cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg15Sum)){
			cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii = parseInt(cgosIncome.cgInc.stcg.prctg15.sec115ad_1_b_ii) + parseInt(amtSetOff) - parseInt(prctg15Sum);
			amtSetOff = zeroOrMore(parseInt(prctg15Sum));
		}
	}

	return amtSetOff;
}

//To setOff Against section 15 Pti
function setOffAgainst15Pti(value, cgosIncome){


	var prctg15 = cgosIncome.cgInc.stcg.prctg15;
	var prctg15Sum = eval( parseInt(prctg15.sec111a,10) +
							 parseInt(prctg15.sec115ad_1_b_ii,10)+
							 parseInt(prctg15.secPti,10));

	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10) > 0){
		if(parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.stcg.prctg15.secPti = eval( parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.stcg.prctg15.secPti, 10));
			cgosIncome.cgInc.stcg.prctg15.secPti = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg15Sum)){
			cgosIncome.cgInc.stcg.prctg15.secPti = parseInt(cgosIncome.cgInc.stcg.prctg15.secPti) + parseInt(amtSetOff) - parseInt(prctg15Sum);
			amtSetOff = zeroOrMore(parseInt(prctg15Sum));
		}
	}

	return amtSetOff;
}

//To setOff Against section 112
function setOffAgainst112(value, cgosIncome){


	var prctg20 = cgosIncome.cgInc.ltcg.prctg20;
	var prctg20Sum = zeroOrMore(eval( parseInt(prctg20.sec112,10) +
							 parseInt(prctg20.sec11EA,10) +
							 parseInt(prctg20.secPti,10)));

	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg20.sec112 = eval( parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112, 10));
			cgosIncome.cgInc.ltcg.prctg20.sec112 = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg20Sum)){
			cgosIncome.cgInc.ltcg.prctg20.sec112 = parseInt(cgosIncome.cgInc.ltcg.prctg20.sec112) + parseInt(amtSetOff) - parseInt(prctg20Sum);
			amtSetOff = zeroOrMore(parseInt(prctg20Sum));
		}
	}
	return amtSetOff;
}

//To setOff Against section 115EA
function setOffAgainst115Ea(value, cgosIncome){
	var prctg20 = cgosIncome.cgInc.ltcg.prctg20;
	var prctg20Sum = zeroOrMore(eval( parseInt(prctg20.sec112,10) +
							 parseInt(prctg20.sec11EA,10)+
							 parseInt(prctg20.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg20.sec11EA = eval( parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA, 10));
			cgosIncome.cgInc.ltcg.prctg20.sec11EA = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg20Sum)){
			cgosIncome.cgInc.ltcg.prctg20.sec11EA = parseInt(cgosIncome.cgInc.ltcg.prctg20.sec11EA) + parseInt(amtSetOff) - parseInt(prctg20Sum);
			amtSetOff = zeroOrMore(parseInt(prctg20Sum));
		}
	}


	return amtSetOff;
}

//To setOff Against section Pti
function setOffAgainst20Pti(value, cgosIncome){
	var prctg20 = cgosIncome.cgInc.ltcg.prctg20;
	var prctg20Sum = zeroOrMore(eval( parseInt(prctg20.sec112,10) +
							 parseInt(prctg20.sec11EA,10)+
							 parseInt(prctg20.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg20.secPti = eval( parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti, 10));
			cgosIncome.cgInc.ltcg.prctg20.secPti = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg20Sum)){
			cgosIncome.cgInc.ltcg.prctg20.secPti = parseInt(cgosIncome.cgInc.ltcg.prctg20.secPti) + parseInt(amtSetOff) - parseInt(prctg20Sum);
			amtSetOff = zeroOrMore(parseInt(prctg20Sum));
		}
	}


	return amtSetOff;
}

//To setOff Against section Pti
function setOffAgainst10Pti(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.secPti = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti, 10));
			cgosIncome.cgInc.ltcg.prctg10.secPti = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.secPti = parseInt(cgosIncome.cgInc.ltcg.prctg10.secPti) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}


	return amtSetOff;
}

//To setOff Against section Proviso
function setOffAgainstsecProviso(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.secProviso = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso, 10));
			cgosIncome.cgInc.ltcg.prctg10.secProviso = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.secProviso = parseInt(cgosIncome.cgInc.ltcg.prctg10.secProviso) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}



	return amtSetOff;
}
//To setOff Against section Proviso
function setOffAgainstsec115ADiiiP(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP, 10));
			cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ADiiiP) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}



	return amtSetOff;
}
//To setOff Against section Proviso
function setOffAgainstsec112A(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10) ));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.sec112A = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A, 10));
			cgosIncome.cgInc.ltcg.prctg10.sec112A = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.sec112A = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112A) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}


	return amtSetOff;
}
//To setOff Against section 112_1_c_2
function setOffAgainst112_1_c_2(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2 = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2, 10));
			cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2 = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec112_1_c_2) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}

	return amtSetOff;
}
//To setOff Against section 115AC_1
function setOffAgainst115AC_1(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.sec115AC_1 = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1, 10));
			cgosIncome.cgInc.ltcg.prctg10.sec115AC_1 = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.sec115AC_1 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AC_1) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}

	}



	return amtSetOff;
}
//To setOff Against section 115ACA_1
function setOffAgainst115ACA_1(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1, 10));
			cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 = 0;
		}

		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115ACA_1) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}

	return amtSetOff;
}
//To setOff Against section 115AD_3
function setOffAgainst115AD_3(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
			 parseInt(prctg10.sec112_1_c_2,10) +
			 parseInt(prctg10.sec115AC_1,10) +
			 parseInt(prctg10.sec115ACA_1,10) +
			 parseInt(prctg10.sec115AD_3,10) +
			 parseInt(prctg10.sec115ADiiiP,10) +
			 parseInt(prctg10.sec115E_b,10) +
			 parseInt(prctg10.sec112A,10)+
			 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.sec115AD_3 = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3, 10));
			cgosIncome.cgInc.ltcg.prctg10.sec115AD_3 = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.sec115AD_3 = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115AD_3) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}

	return amtSetOff;
}
//To setOff Against section 115E_b
function setOffAgainst115E_b(value, cgosIncome){
	var prctg10 = cgosIncome.cgInc.ltcg.prctg10;
	var prctg10Sum = zeroOrMore(eval( parseInt(prctg10.secProviso,10) +
							 parseInt(prctg10.sec112_1_c_2,10) +
							 parseInt(prctg10.sec115AC_1,10) +
							 parseInt(prctg10.sec115ACA_1,10) +
							 parseInt(prctg10.sec115AD_3,10) +
							 parseInt(prctg10.sec115ADiiiP,10) +
							 parseInt(prctg10.sec115E_b,10) +
							 parseInt(prctg10.sec112A,10)+
							 parseInt(prctg10.secPti,10)));
	var amtSetOff = 0;
	if(parseInt(value, 10) < 0 && parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10) > 0){
		if(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10) >= Math.abs(parseInt(value, 10))){
			cgosIncome.cgInc.ltcg.prctg10.sec115E_b = eval( parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10) +
												  parseInt(value, 10));
			amtSetOff = Math.abs(parseInt(value, 10));
		}else{
			amtSetOff = Math.abs(parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b, 10));
			cgosIncome.cgInc.ltcg.prctg10.sec115E_b = 0;
		}
		if(parseInt(amtSetOff) > parseInt(prctg10Sum)){
			cgosIncome.cgInc.ltcg.prctg10.sec115E_b = parseInt(cgosIncome.cgInc.ltcg.prctg10.sec115E_b) + parseInt(amtSetOff) - parseInt(prctg10Sum);
			amtSetOff = zeroOrMore(parseInt(prctg10Sum));
		}
	}

	return amtSetOff;
}

//To set Profit Loss
function setProfitLoss(value, lossFld, profitFld){
	if(parseInt(value, 10) < 0){
		document.getElementsByName(lossFld)[0].value = Math.abs(value);
		document.getElementsByName(profitFld)[0].value = 0;
	}else if(parseInt(value, 10) > 0){
		document.getElementsByName(lossFld)[0].value = 0;
		document.getElementsByName(profitFld)[0].value = Math.abs(value);
	}else{
		document.getElementsByName(lossFld)[0].value = 0;
		document.getElementsByName(profitFld)[0].value = 0;
	}
}

//////////////////////////////CG Calculation Ends/////////////////////////////////

function calcCFL_sumAll(){
	try{
		//HP Loss :: total of earlier year losses
		coalescePath('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.hpLossCF');
		document.getElementsByName('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.hpLossCF')[0].value =
			coalescePath('scheduleCFL.lossCFFromPrev8ThYearFromAY.carryFwdLossDetail.hpLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev7ThYearFromAY.carryFwdLossDetail.hpLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev6ThYearFromAY.carryFwdLossDetail.hpLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev5ThYearFromAY.carryFwdLossDetail.hpLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev4ThYearFromAY.carryFwdLossDetail.hpLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev3RdYearFromAY.carryFwdLossDetail.hpLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev2NdYearFromAY.carryFwdLossDetail.hpLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrevYrToAY.carryFwdLossDetail.hpLossCF');

		//Short-term capital loss
		coalescePath('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.stcgLossCF');
		document.getElementsByName('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.stcgLossCF')[0].value =
			coalescePath('scheduleCFL.lossCFFromPrev8ThYearFromAY.carryFwdLossDetail.stcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev7ThYearFromAY.carryFwdLossDetail.stcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev6ThYearFromAY.carryFwdLossDetail.stcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev5ThYearFromAY.carryFwdLossDetail.stcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev4ThYearFromAY.carryFwdLossDetail.stcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev3RdYearFromAY.carryFwdLossDetail.stcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev2NdYearFromAY.carryFwdLossDetail.stcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrevYrToAY.carryFwdLossDetail.stcgLossCF');

		//Long-term Capital loss
		coalescePath('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.ltcgLossCF');
		document.getElementsByName('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.ltcgLossCF')[0].value =
			coalescePath('scheduleCFL.lossCFFromPrev8ThYearFromAY.carryFwdLossDetail.ltcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev7ThYearFromAY.carryFwdLossDetail.ltcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev6ThYearFromAY.carryFwdLossDetail.ltcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev5ThYearFromAY.carryFwdLossDetail.ltcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev4ThYearFromAY.carryFwdLossDetail.ltcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev3RdYearFromAY.carryFwdLossDetail.ltcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrev2NdYearFromAY.carryFwdLossDetail.ltcgLossCF')+
			coalescePath('scheduleCFL.lossCFFromPrevYrToAY.carryFwdLossDetail.ltcgLossCF');


		//Other sources loss (from owning race horses)
		coalescePath('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.othSrcLossRaceHorseCF');
		document.getElementsByName('scheduleCFL.totalOfBFLossesEarlierYrs.lossSummaryDetail.othSrcLossRaceHorseCF')[0].value =
			coalescePath('scheduleCFL.lossCFFromPrev4ThYearFromAY.carryFwdLossDetail.othSrcLossRaceHorseCF')+
			coalescePath('scheduleCFL.lossCFFromPrev3RdYearFromAY.carryFwdLossDetail.othSrcLossRaceHorseCF')+
			coalescePath('scheduleCFL.lossCFFromPrev2NdYearFromAY.carryFwdLossDetail.othSrcLossRaceHorseCF')+
			coalescePath('scheduleCFL.lossCFFromPrevYrToAY.carryFwdLossDetail.othSrcLossRaceHorseCF');


	}catch(e){
		alert('error in calcCFL_sumALL=' + e);
	}
}

//To get LTCG 20 ExmpFrmSI
function getLTCG20ExmpFrmSI(){
	var inc = {"10":0, "20":0};
	var afterExmp = {"10":0, "20":0};
	var tab = document.getElementById('scheduleSI');
	var allInput = tab.getElementsByTagName("INPUT");
	for(var i=0;i<allInput.length;i++){
		if(allInput[i].name.match('secCode$')){
			index = allInput[i].name.substring(allInput[i].name.indexOf('[')+1,allInput[i].name.indexOf(']'));
			if(allInput[i].value=='22'||allInput[i].value=='2A'){
				inc["10"] = eval(parseInt(inc["10"]) + coalesceSetRet('scheduleSI.splCodeRateTax[' + index + '].splRateInc'));
				afterExmp["10"] = eval(parseInt(afterExmp["10"]) + coalesceSetRet('scheduleSI.splCodeRateTax[' + index + '].taxableInc'));

			}else if(allInput[i].value=='21'){
				inc["20"] = eval(parseInt(inc["20"]) + coalesceSetRet('scheduleSI.splCodeRateTax[' + index + '].splRateInc'));
				afterExmp["20"] = eval(parseInt(afterExmp["20"]) + coalesceSetRet('scheduleSI.splCodeRateTax[' + index + '].taxableInc'));

			}
		}
	}
	return {"10":(inc["10"]-afterExmp["10"]), "20":(inc["20"]-afterExmp["20"])};

}

//To delete Row from FSI
function deleteRowFSI(tableId , noOfHeader , noOfFooter){
	try{
		var mytable = document.getElementById(tableId);
		var rowCount = mytable.rows.length;
		var itemCount = (rowCount - 4 )/ 6;
		noOfHeader = parseInt(noOfHeader , 10);
		var isChecked=false;
		var listOfCheckBox = mytable.getElementsByTagName('input');
		var totalChecked = 0;
		for(var z=0; z<listOfCheckBox.length; z++){
			if(listOfCheckBox[z].name.match(".chosenCheckBox$")){
				if(listOfCheckBox[z].checked==true){
					totalChecked = eval( parseInt(totalChecked,10) +1);
					isChecked=true;
				}
			}
		}
		if(!isChecked){
			addErrorXHTML('','Please select a checkbox for deleting row');
		}

		for(var j=1; j<=totalChecked ; j++){      // iterate for total number of checkboxes
			var totalNoOfInput = mytable.getElementsByTagName('input');

			for(var z=0; z<totalNoOfInput.length; z++){
				if(totalNoOfInput[z].name.match(".chosenCheckBox$")){		// if its a chosenCheckBox element

					var akhilIndex1 = eval(parseInt(totalNoOfInput[z].name.lastIndexOf('[') ,10)+1);
					var akhilIndex2 = eval(parseInt(totalNoOfInput[z].name.lastIndexOf(']') ,10));
					var rowNumber = totalNoOfInput[z].name.substring(akhilIndex1, akhilIndex2);
					rowNumber = parseInt(rowNumber ,10);

					var myCurrtable = document.getElementById(tableId);
					var rowCurrCount = myCurrtable.rows.length;


					if(totalNoOfInput[z].checked==true){
						if((rowNumber!=0) || (rowNumber==0 &&  parseInt(eval(rowCurrCount-noOfHeader-noOfFooter)/6)>1) ){
							rowNumber = eval(parseInt(rowNumber,10) * 6 + noOfHeader);
							for(var i=0;i<6;i++){
								mytable.deleteRow(rowNumber);
							}
							//To Do - reset the name of row for all input , textarea, select
							var newTrList = mytable.getElementsByTagName('tr');
							var newTrListLength = eval(parseInt(newTrList.length ,10)-noOfFooter);
							for( var q=rowNumber; q < newTrListLength ; q++ ){	//iterate over all rows from delete point to second last row
								var p = parseInt((q-noOfHeader) /6) + noOfHeader;
								//set the serial number;
								if((q-noOfHeader)%6==0){
									if(noOfHeader==2){
										newTrList[q].getElementsByTagName('td')[0].innerHTML = parseInt(p-1,10);
									}else if(noOfHeader==1){
										newTrList[q].getElementsByTagName('td')[0].innerHTML = parseInt(p,10);
									}else if(noOfHeader==3){
										newTrList[q].getElementsByTagName('td')[0].innerHTML = parseInt(p-2,10);
									}
								}
								var allInputTags = newTrList[q].getElementsByTagName('input');

								for(var zz=0; zz<allInputTags.length ; zz++ ){
									var index1= allInputTags[zz].name.lastIndexOf('[');
									var index2= allInputTags[zz].name.lastIndexOf(']');

									var str1 = allInputTags[zz].name.substring(0, index1);
									var str3 = allInputTags[zz].name.substring(index2 + 1, allInputTags[zz].name.length);

									allInputTags[zz].name = str1+'[' +eval(parseInt(p,10)-noOfHeader) +']'+str3;
								}

								var allSelectTags = newTrList[q].getElementsByTagName('select');

								for(var zz=0; zz<allSelectTags.length ; zz++ ){
									var index1= allSelectTags[zz].name.lastIndexOf('[');
									var index2= allSelectTags[zz].name.lastIndexOf(']');

									var str1 = allSelectTags[zz].name.substring(0, index1);
									var str3 = allSelectTags[zz].name.substring(index2 + 1, allSelectTags[zz].name.length);

									allSelectTags[zz].name = str1+'[' +eval(parseInt(p,10)-noOfHeader) +']'+str3;
								}

								var allTextAreaTags = newTrList[q].getElementsByTagName('textarea');

								for(var zz=0; zz<allTextAreaTags.length ; zz++ ){
									var index1= allTextAreaTags[zz].name.lastIndexOf('[');
									var index2= allTextAreaTags[zz].name.lastIndexOf(']');

									var str1 = allTextAreaTags[zz].name.substring(0, index1);
									var str3 = allTextAreaTags[zz].name.substring(index2 + 1, allTextAreaTags[zz].name.length);

									allTextAreaTags[zz].name = str1+'[' +eval(parseInt(p,10)-noOfHeader) +']'+str3;
								}
							}
							break;
						}else if((rowNumber==0)  && (parseInt(eval(rowCurrCount-noOfHeader-noOfFooter)/6)==1)){
							//Vacate the content if its first row

							for(var m=0; m<5; m++){
								var firstRow = mytable.getElementsByTagName('tr')[parseInt(noOfHeader) + m];

								var firstInputBox = firstRow.getElementsByTagName('input')[0];
								if(firstInputBox!=undefined){
									firstInputBox.checked = false;
								}


								var allInputTags = firstRow.getElementsByTagName('input');
								for ( var i = 0; i < allInputTags.length; i++) {
									allInputTags[i].value = "";
								}
								var allSelectTags = firstRow.getElementsByTagName('select');
								for ( var i = 0; i < allSelectTags.length; i++) {
									var elem = allSelectTags[i];
									elem[0].selected = true;
								}
								var allTextAreaTags = firstRow.getElementsByTagName('textarea');
								for ( var i = 0; i < allTextAreaTags.length; i++) {
									allTextAreaTags[i].value = "";
								}
							}
						}
					}
				}
			}
		}
	}catch(e){
		alert('exception caught in =' +e );
	}
}

//To set sch SI Description
function setSIDesc(){
	var tab = document.getElementById('scheduleSI');
	var inputs = tab.getElementsByTagName("INPUT");
	for(var i=0;i<inputs.length;i++){
		if(inputs[i].name.match('secCode$')){
			var row = inputs[i].parentNode.parentNode;
			row.cells[1].innerHTML = getSectionTextMap(inputs[i].value);
		}
	}
}

//To get Slabbed Income
function getSlabbedIncome(totalIncome){

	var taxPayer = document.getElementsByName('partAGEN1.personalInfo.status')[0];
	//IN-I,HUF-H
	var resStatus 			= document.getElementsByName('partAGEN1.filingStatus.residentialStatus')[0]; //RES , NRI

	var age	= calcAge();

	var netTxblIncome 		= totalIncome;

	var inc = {"5":0,"20":0,"30":0};

	if(taxPayer.value=='I' && age > 59 && age < 80 && (resStatus.value=='RES' || resStatus.value=='NOR')){

		if(parseInt(netTxblIncome,10) >= parseInt('0',10) && parseInt(netTxblIncome,10) <= parseInt('300000',10)){
			inc = {"5":0, "20":0, "30":0};
		}else if(parseInt(netTxblIncome,10) >= parseInt('300001',10) && parseInt(netTxblIncome,10) <= parseInt('500000',10)){
			inc = {"5":(parseInt(netTxblIncome,10) - 300000), "20":0, "30":0};
		}else if(parseInt(netTxblIncome,10) >= parseInt('500001',10) && parseInt(netTxblIncome,10) <= parseInt('1000000',10)){
			inc = {"5":200000, "20":(parseInt(netTxblIncome,10) - 500000), "30":0};
		}else if(parseInt(netTxblIncome,10) >= parseInt('1000001',10)){
			inc = {"5":200000, "20":500000, "30":(parseInt(netTxblIncome,10) - 1000000)};
		}

	}else if(taxPayer.value=='I' && age >= 80 && (resStatus.value=='RES' || resStatus.value=='NOR')){

		if(parseInt(netTxblIncome,10) >= parseInt('0',10) && parseInt(netTxblIncome,10) <= parseInt('500000',10)){
			inc = {"5":0, "20":0, "30":0};
		}else if(parseInt(netTxblIncome,10) >= parseInt('500001',10) && parseInt(netTxblIncome,10) <= parseInt('1000000',10)){
			inc = {"5":0, "20":(parseInt(netTxblIncome,10) - 500000), "30":0};

		}else if(parseInt(netTxblIncome,10) >= parseInt('1000001',10)){
			inc = {"5":0, "20":500000, "30":(parseInt(netTxblIncome,10) - 1000000)};
		}


	}else if( (taxPayer.value=='I') || taxPayer.value=='H' ){

		if(parseInt(netTxblIncome,10) >= parseInt('0',10) && parseInt(netTxblIncome,10) <= parseInt('250000',10)){
			inc = {"5":0, "20":0, "30":0};
		}else if(parseInt(netTxblIncome,10) >= parseInt('250001',10) && parseInt(netTxblIncome,10) <= parseInt('500000',10)){
			inc = {"5":(parseInt(netTxblIncome,10) - 250000), "20":0, "30":0};
		}else if(parseInt(netTxblIncome,10) >= parseInt('500001',10) && parseInt(netTxblIncome,10) <= parseInt('1000000',10)){
			inc = {"5":250000, "20":(parseInt(netTxblIncome,10) - 500000), "30":0};
		}else if(parseInt(netTxblIncome,10) >= parseInt('1000001',10)){
			inc = {"5":250000, "20":500000, "30":(parseInt(netTxblIncome,10) - 1000000)};
		}

	}
	return inc;
}

//To do custom Import
function customImport(fieldId,rowCount,type){
	if(((fieldId.indexOf('scheduleCGPost45.longTermCapGainPost45.nRIOnSec112and115')!=-1 &&
		fieldId.indexOf('.exemptionOrDedn[')==-1) ||
		fieldId.indexOf('scheduleCGPost45.shortTermCapGainPost45.equityMFonSTT')!=-1 ||
		(fieldId.indexOf('scheduleCGPost45.longTermCapGainPost45.proviso112Applicable')!=-1 &&
		fieldId.indexOf('.exemptionOrDedn[')==-1))){
			addRowToCG(getTableId(fieldId));
			return true;
	}
	return false;
    }

//To check Unique sch OS Sec
function checkUniqueOSSec(){

	checkUniqueTableCol('scheduleCGstcg2', 'section$');
	checkUniqueTableCol('ltcgDeduction2', 'section$');
	checkUniqueTableCol('ltcgDeduction112A', 'section$');
	checkUniqueTableCol('ltcgDeduction7112A', 'section$');
	checkUniqueTableCol('scheduleCGltcg3', 'sectionCode$');

	var i = 1;
	while(document.getElementById('scheduleCGltcg3_ded'+i)){
		checkUniqueTableCol('scheduleCGltcg3_ded'+i, 'section$');
		i++;
	}

	i=1;
	while(document.getElementById('stcg10pctTab_ded'+i)){
		checkUniqueTableCol('stcg10pctTab_ded'+i, 'section$');
		i++;
	}

	var table = document.getElementById('scheduleCGltcg1');
	var noOfRows = table.rows.length;

	var valueB1d = parseInt('0',10);
	for (var i = 0; i <noOfRows/14; i++) {
		var r = i+1;
		var tableId = 'ltcgDeduction1_ded'+r;
		checkUniqueTableCol(tableId, 'section$');
	}
	checkUniqueTableCol('scheduleCGltcg7', 'section$');
}

//To check Unique Table Column in schedule
function checkUniqueTableCol(tableId, colname,errorMesg){

	var tab = document.getElementById(tableId);
	var selects = tab.getElementsByTagName('SELECT');
	var arr = new Array();
	for(var i=0;i<selects.length;i++){
		if(selects[i].name.match(colname) && selects[i].value!=''){
			if(arr.indexOf(selects[i].value)==-1){
				arr.push(selects[i].value);
			}else if(selects[i].value!='Others'){
				var msg = errorMesg || 'A particular drop down cannot be selected twice';
				j.setFieldError(selects[i].name, msg);
				addErrorXHTML(selects[i], msg ,true);
			}
		}
	}
}



//To delete row from PTI
function deleteRowPTI(tableId , noOfHeader , noOfFooter){
	try{
		var mytable = document.getElementById(tableId);
		var rowCount = mytable.rows.length;
		var itemCount = (rowCount - 3 )/ 9;
		noOfHeader = parseInt(noOfHeader , 10);
		var isChecked=false;
		var listOfCheckBox = mytable.getElementsByTagName('input');
		var totalChecked = 0;
		for(var z=0; z<listOfCheckBox.length; z++){
			if(listOfCheckBox[z].name.match(".chosenCheckBox$")){
				if(listOfCheckBox[z].checked==true){
					totalChecked = eval( parseInt(totalChecked,10) +1);
					isChecked=true;
				}
			}
		}
		if(!isChecked){
			addErrorXHTML('','Please select a checkbox for deleting row');
		}

		for(var j=1; j<=totalChecked ; j++){
			var totalNoOfInput = mytable.getElementsByTagName('input');

			for(var z=0; z<totalNoOfInput.length; z++){
				if(totalNoOfInput[z].name.match(".chosenCheckBox$")){

					var akhilIndex1 = eval(parseInt(totalNoOfInput[z].name.lastIndexOf('[') ,10)+1);
					var akhilIndex2 = eval(parseInt(totalNoOfInput[z].name.lastIndexOf(']') ,10));
					var rowNumber = totalNoOfInput[z].name.substring(akhilIndex1, akhilIndex2);
					rowNumber = parseInt(rowNumber ,10);

					var myCurrtable = document.getElementById(tableId);
					var rowCurrCount = myCurrtable.rows.length;


					if(totalNoOfInput[z].checked==true){
						if((rowNumber!=0) || (rowNumber==0 &&  parseInt(eval(rowCurrCount-noOfHeader-noOfFooter)/9)>1) ){
							rowNumber = eval(parseInt(rowNumber,10) * 9 + noOfHeader);
							for(var i=0;i<9;i++){
								mytable.deleteRow(rowNumber);
							}
							//To Do - reset the name of row for all input , textarea, select
							var newTrList = mytable.getElementsByTagName('tr');
							var newTrListLength = eval(parseInt(newTrList.length ,10)-noOfFooter);
							for( var q=rowNumber; q < newTrListLength ; q++ ){
								var p = parseInt((q-noOfHeader) /9) + noOfHeader;
								//set the serial number;
								if((q-noOfHeader)%9==0){
									if(noOfHeader==2){
										newTrList[q].getElementsByTagName('td')[0].innerHTML = parseInt(p-1,10);
									}else if(noOfHeader==1){
										newTrList[q].getElementsByTagName('td')[0].innerHTML = parseInt(p,10);
									}else if(noOfHeader==3){
										newTrList[q].getElementsByTagName('td')[0].innerHTML = parseInt(p-2,10);
									}
								}
								var allInputTags = newTrList[q].getElementsByTagName('input');

								for(var zz=0; zz<allInputTags.length ; zz++ ){
									var index1= allInputTags[zz].name.lastIndexOf('[');
									var index2= allInputTags[zz].name.lastIndexOf(']');

									var str1 = allInputTags[zz].name.substring(0, index1);
									var str3 = allInputTags[zz].name.substring(index2 + 1, allInputTags[zz].name.length);

									allInputTags[zz].name = str1+'[' +eval(parseInt(p,10)-noOfHeader) +']'+str3;
								}

								var allTextAreaTags = newTrList[q].getElementsByTagName('textarea');

								for(var zz=0; zz<allTextAreaTags.length ; zz++ ){
									var index1= allTextAreaTags[zz].name.lastIndexOf('[');
									var index2= allTextAreaTags[zz].name.lastIndexOf(']');

									var str1 = allTextAreaTags[zz].name.substring(0, index1);
									var str3 = allTextAreaTags[zz].name.substring(index2 + 1, allTextAreaTags[zz].name.length);

									allTextAreaTags[zz].name = str1+'[' +eval(parseInt(p,10)-noOfHeader) +']'+str3;
								}
							}
							break;
						}else if((rowNumber==0)  && (parseInt(eval(rowCurrCount-noOfHeader-noOfFooter)/9)==1)){
							//Vacate the content if its first row

							for(var m=0; m<9; m++){
								var firstRow = mytable.getElementsByTagName('tr')[parseInt(noOfHeader) + m];

								var firstInputBox = firstRow.getElementsByTagName('input')[0];
								firstInputBox.checked = false;

								var allInputTags = firstRow.getElementsByTagName('input');
								for ( var i = 0; i < allInputTags.length; i++) {
									allInputTags[i].value = "";
								}
								var allSelectTags = firstRow.getElementsByTagName('select');
								for ( var i = 0; i < allSelectTags.length; i++) {
									var elem = allSelectTags[i];
									elem[0].selected = true;
								}
								var allTextAreaTags = firstRow.getElementsByTagName('textarea');
								for ( var i = 0; i < allTextAreaTags.length; i++) {
									allTextAreaTags[i].value = "";
								}
							}
						}
					}
				}
			}
		}
	}catch(e){
		alert('exception caught in =' +e );
	}
}